/*

Copyright _ 2005, dana 'mania'
riverrunner@gmail.com
if you have any suggestions or improvements for this widget please let me know.

*/

var daysdata = 5; // how many days to get (changing this affects styles)
var graphwidth = 288; // default width of graph in px
var graphheight = 100; // height of graph in px
var usgspage = ""; // big string of the web page
var usgsline = new Array(); // array of lines of web page
var usgscol = new Array(); // array of columns of lines
var flodatetime = new Array(); // datetime of flow reading
var setmsg = ""; // if error message
var j = 0; // counter
var xmlhttp;
var mystatus = "";
var nits = 'cfs';
var units = "CFS";
// variables for CFS
var maxcfs = 0;
var mincfs = 100000;
var currentcfs = 0;
var cfs = new Array();
var cfscopy = new Array();
// variables for FT
var maxft = 0;
var minft = 100;
var currentft = 0;
var ft = new Array();
var ftcopy = new Array();

// change inner HTML based on element id
function tellit(wheretosayit,whattosay)
{
	document.getElementById(wheretosayit).innerHTML = whattosay;
}

function mytest() {
	xmlhttp = new XMLHttpRequest();
	var url = "http://localhost/~riverrunner/b/bitcastle.net/wwwidget/mult.txt"
	xmlhttp.open("GET",url,false);
	xmlhttp.send(null);
	mystatus = "";
	mystatus = xmlhttp.status;
	if (mystatus == "200") {
		setmsg = xmlhttp.responseText;
		tellit('mymsg',setmsg);
	} else {
		setmsg = "PAGE NOT FOUND";
		tellit('mymsg',setmsg);
	}
}

function myxmlhttp(riv) {
	if (riv != '') {
		xmlhttp = new XMLHttpRequest();
		//var url = "http://localhost/~riverrunner/"+riv+".txt";
		var url = "http://waterdata.usgs.gov/nwis/uv?format=rdb&period=5&site_no="+riv;
		xmlhttp.open("GET",url,false);
		xmlhttp.send(null);
		mystatus = "";
		mystatus = xmlhttp.status;
		if (mystatus == "200") {
			setmsg = "";
			tellit('mymsg',setmsg);
			//hideit();
			proceed(riv);
		} else {
			clearit();
			setmsg = "PAGE NOT FOUND";
			tellit('mymsg',setmsg);
		}
	}
}

// gets the tab delimited data for USGS site number
function proceed(riv)
{
	// reset some things so you dont have to reload
	usgspage = "";
	newpage = ""; // debug variable
	maxcfs = 0;
	mincfs = 1000000;
	currentcfs = 0;
	maxft = 0;
	minft = 100;
	currentft = 0;
	j = 0;
	usgsline.length = 0;
	flodatetime.length = 0;
	cfs.length = 0;
	cfscopy.length = 0;
	ft.length = 0;
	ftcopy.length = 0;
	var cfsindex = 4;
	var ftindex = 3;
	var tempcol = new Array();

	// read in the page as tab and line delimited text
	usgspage = xmlhttp.responseText;
	usgsline = usgspage.split("\n");
	
	for (var i = 0; i < usgsline.length; i++) {
		// find out which col has ft or cfs or nothing
		if (usgsline[i].substring(0,6) == "agency") { // if line starts with agency
			tempcol.length = 0;
			tempcol = usgsline[i].split("\t"); // split tabs
			// see if cols exist
			if (tempcol[4] != undefined) {
				if (tempcol[4].slice(3,8) == "00060") { // ft
					cfsindex = 4;
				} else if (tempcol[4].slice(3,8) == "00065") { // ft
					ftindex = 4;
				}
				
			}
			if (tempcol[3] != undefined) {
				if (tempcol[3].slice(3,8) == "00060") { // ft
					cfsindex = 3;
				} 
				if (tempcol[3].slice(3,8) == "00065") { // ft
					ftindex = 3;
				}
			}
		}
		// only get rows with data in them
		if (usgsline[i][0] == "U") { // if line starts with USGS
			usgscol = usgsline[i].split("\t"); // split tabs
			if (usgscol[2] != "") { // if datetime not null keep going
				// skip some rows if more than 96 data points per day
				if (usgscol[2].slice(14) == "00" || usgscol[2].slice(14) == "15" || usgscol[2].slice(14) == "30" || usgscol[2].slice(14) == "45") {
					// CFS
					if (usgscol[cfsindex] > 0) { 
						cfs[j] = usgscol[cfsindex]; // form new array of cfs
						cfscopy[j] = usgscol[cfsindex]; // for sorting
					} else {
						cfs[j] = cfs[j-1]; // use last value if this one is null for some reason
						cfscopy[j] = cfs[j-1];
					}
					// FT
					if (usgscol[ftindex] > 0) { 
						ft[j] = usgscol[ftindex]; // form new array of ft
						ftcopy[j] = usgscol[ftindex]; // for sorting
					} else {
						ft[j] = ft[j-1]; // use last value if this one is null for some reason
						ftcopy[j] = ft[j-1];
					}
					flodatetime[j] = usgscol[2]; // form new array of datetime
					j++; // new counter
				}
			}
		}
	}
	if (setmsg == "") {
		// sort copy of array to get max and min
		cfscopy.sort(function(a,b) {
			return a-b;
		});
		mincfs = cfscopy[0];
		maxcfs = cfscopy[cfscopy.length -1];
		currentcfs = cfs[cfs.length -1];

		// repeat for feet
		ftcopy.sort(function(a,b) {
			return a-b;
		});
		minft = ftcopy[0];
		maxft = ftcopy[ftcopy.length -1];
		currentft = ft[ft.length -1];

		tellit('sitenumber','SITE: ' + riv);
		tellit('currentflo','FLOW: ' + currentcfs + ' CFS | '  + currentft + ' FT');
		plotit(nits);
		tellit('mymsg','');
	} else {
		tellit('mymsg',setmsg);
	}
}

// function to change units
function chu()
{
	if (units == "CFS") {
		nits = "ft";
	} else {
		nits = "cfs";
	}
	plotit(nits);
}

// plot data to a graph using apple canvas
function plotit(nits)
{
	var graphmax = 0;
	var graphmin = 0;
	var graphrange = 0;
	var mymax = 0;
	var mymin = 0;
	var myrange = 0;
	var mysize = 0;
	var myscale = 0;
	var factor = 1;
	var myslop = 0.02;

	if (nits == 'ft') {
		units = "FT";
		flodata = ft;
		mymax = maxft;
		mymin = minft;
		if ((mymax - mymin) < 1) {
			factor = 100;
			fixed = 2;
		} else {
			factor = 10;
			fixed = 1;
		}
	} else {
		units = "CFS";
		flodata = cfs;
		factor = 1;
		mymax = maxcfs;
		mymin = mincfs;
	}
	// determine the scale and add slop
	// not sure why but these insisted on being strings without the Number()???
	mymax = Number(mymax) + Number(mymax)*Number(myslop);
	mymin = Number(mymin) - Number(mymin)*Number(myslop);
	myrange = Math.round((mymax - mymin)*100)/100;
// 	if (myrange < mymax*0.1) {
// 		myrange = Number(myrange) + Number(myrange)*0.1;
// 	}
	mysize = Math.ceil(myrange) + "";
	myscale = Math.pow(10,mysize.length - 1); // turns scale to a power of 10 (10, 100, 1000 etc)
	graphmax = Math.ceil(2*mymax/myscale*factor)/factor*myscale/2; // turns boundary increments to 50, 100, etc
	graphmin = Math.floor(2*mymin/myscale*factor)/factor*myscale/2;
	graphrange = graphmax - graphmin;
	var canvas = document.getElementById("mycanvas");
	var context = canvas.getContext("2d");
	context.beginPath();
	// draw box to graph in
	context.fillStyle = "#339999";
	context.fillRect(0,0,graphwidth,graphheight);
	
	// draw some lines for y axix
	for (var d = 0; d < 5; d++) {
		context.moveTo(0,graphheight*d/4);
		context.lineTo(graphwidth,graphheight*d/4);
		// change labels
		var myunits = "";
		if (d == 2) {
			myunits = " "+units;
		} else {
			myunits = "";
		}
		var yval = Math.round((graphmax-graphrange*d/4)*factor)/factor;
		if (nits == 'ft') {
			yval = yval.toFixed(fixed);
		}
		document.getElementById('y-label-' + d).innerHTML = yval + myunits;
	}
	
	context.lineWidth = 1;
	context.shadowBlur = 0;
	context.shadowOffsetX = 0;
	context.shadowOffsetY = 0;
	context.strokeStyle = "#333333"; //y axis
	context.stroke();
	
	// find out how many points per day
	// i have seen 24 (every hour), 96 (every 15 mins / most common), and 130 (an oddball)
	for (var ppd = 1; ppd < flodatetime.length; ppd++) {
		if (flodatetime[ppd].slice(11,16) == flodatetime[0].slice(11,16)) {
			break;
		}
	}
	
	// draw some lines for x axis
	for (var f = 0; f < daysdata + 2; f++) {
		context.moveTo(graphwidth/(daysdata + 1)*f,0);
		context.lineTo(graphwidth/(daysdata + 1)*f,graphheight);
		// change labels
		var midp = ppd*f;
		if (flodatetime[midp] != null) {
			document.getElementById('x-label-' + f).innerHTML = flodatetime[midp].slice(5,10);
		}
	}
	// stroke lines and set color
	context.lineWidth = 1;
	context.shadowBlur = 0;
	context.shadowOffsetX = 0;
	context.shadowOffsetY = 0;
	context.strokeStyle = "#333333"; // x axis
	context.stroke();
	
	// draw the graph of data and normalize data
	var pixi = graphwidth/(daysdata + 1)/ppd; // x axis factor (2, 1/2, 
	context.moveTo(0,(graphmax-flodata[0])*graphheight/graphrange);
	for (var k = 1; k < flodata.length; k=k+4/pixi) {
		context.lineTo(k*pixi,(graphmax-flodata[k])*graphheight/graphrange);
	}
	context.lineWidth = 2;
	context.shadowBlur = 3;
	context.shadowColor = 'rgb(10, 10, 10)';
	context.shadowOffsetX = 1;
	context.shadowOffsetY = 2;
	context.strokeStyle = "#00FF00";
	context.stroke();
}

// PREFS //

// get sites by state
function getsites(state_id)
{
	var sitepage = "";
	var siteline = new Array();
	siteline.length = 0;
	var sitecol = new Array();
	sitecol.length = 0;
	var sitea = new Array();
	sitea.length = 0;
	var count = 0;
	xmlhttp = new XMLHttpRequest();
	//var url = "http://localhost/~riverrunner/w/whitewaterwidget/sites_"+state_id+".txt";
// 	var url = "http://waterdata.usgs.gov/nwis/inventory?state_cd="+state_id+"&station_type_cd=Y______&data_type=rt&sort_key=site_no&group_key=huc_cd&format=sitefile_output&sitefile_output_format=rdb&column_name=agency_cd&column_name=site_no&column_name=station_nm&list_of_search_criteria=state_cd%2Cstation_type_cd%2Cdata_type";
	var url = "http://waterdata.usgs.gov/nwis/uv?state_cd="+state_id+"&station_type_cd=Y______&index_pmcode_00065=3&index_pmcode_00060=4&format=sitefile_output&sort_key=site_no&group_key=huc_cd&sitefile_output_format=rdb&column_name=agency_cd&column_name=site_no&column_name=station_nm&period=5&begin_date=&end_date=&date_format=YYYY-MM-DD&rdb_compression=file&list_of_search_criteria=station_type_cd%2Crealtime_parameter_selection";

// "http://waterdata.usgs.gov/nwis/uv?state_cd=08&station_type_cd=Y______&index_pmcode_00065=3&index_pmcode_00060=4&sort_key=site_no&group_key=NONE&format=sitefile_output&sitefile_output_format=html_table&column_name=agency_cd&column_name=site_no&column_name=station_nm&period=5&begin_date=&end_date=&date_format=YYYY-MM-DD&rdb_compression=file&list_of_search_criteria=state_cd%2Cstation_type_cd%2Crealtime_parameter_selection"
// 	
// 	"http://waterdata.usgs.gov/nwis/uv?state_cd=08&station_type_cd=Y______&index_pmcode_00065=3&index_pmcode_00060=4&sort_key=site_no&group_key=NONE&format=sitefile_output&sitefile_output_format=rdb&column_name=agency_cd&column_name=site_no&column_name=station_nm&period=5&begin_date=&end_date=&date_format=YYYY-MM-DD&rdb_compression=file&list_of_search_criteria=state_cd%2Cstation_type_cd%2Crealtime_parameter_selection"
	
	xmlhttp.open("GET",url,false);	
	xmlhttp.send(null);
	var sitepage = xmlhttp.responseText;
	var siteline = sitepage.split("\n");
	
	for (var i = 0; i < siteline.length; i++) {
		// new array of data columns
		if (siteline[i][0] == "U") { // if line starts with USGS
			sitecol = siteline[i].split("\t"); // split tabs
			if (sitecol[1] != "") { // check for null values
				sitea[count] = {number: sitecol[1], name: sitecol[2]}; // create array of objects
				count++; // new counter
			}
		}
	}
	sitea.sort(function(a,b) { // sort by name
		if (a.name < b.name) {return -1}
		if (a.name > b.name) {return 1}
		return 0;
	});
	// now populate select menu
	document.getElementById("site_id").length = 0;
	for (var t = 0; t < sitea.length; t++) {
		document.getElementById("site_id").options[t] = new Option(sitea[t].name.substring(0,100),sitea[t].number);
	}
	tellit('backmsg','');
}

// some default stations
var station_numbers = ["09359020","09352900","09380000"];
var station_labels = ["UPPER ANIMAS BELOW SILVERTON","VALLECITO","COLORADO AT LEE'S FERRY (GRAND CANYON)"];

// basically gets prefs of your stations etc.
function setup()
{
	if(window.widget) {
		var checkprefs = widget.preferenceForKey("stationnumbers");
		if (checkprefs == undefined) { // save some prefs
			widget.setPreferenceForKey(station_numbers.join("\t"),"stationnumbers");
			widget.setPreferenceForKey(station_labels.join("\t"),"stationlabels");
		} else { // get prefs
			station_numbers.splice(0);
			station_numbers.length = 0;
			station_numbers = widget.preferenceForKey("stationnumbers").split("\t");
			station_labels = widget.preferenceForKey("stationlabels").split("\t");
		}
	}
	// now populate select menu for back
	document.getElementById("riverpref").length = 0;
	for (var t = 0; t < station_numbers.length; t++) {
		document.getElementById("riverpref").options[t] = new Option(station_labels[t],station_numbers[t]);
	}
	// now populate select menu for front
	document.getElementById("rivermenu").length = 0;
	document.getElementById("rivermenu").options[0] = new Option("-- CHOOSE A RIVER --","");
	for (var t = 0; t < station_numbers.length; t++) {
		document.getElementById("rivermenu").options[t+1] = new Option(station_labels[t],station_numbers[t]);
	}
	// now get the default river??
	//myxmlhttp(document.getElementById("rivermenu").options[1].value);
}

// add a station to your list
function addRiver()
{
	rivercount = document.getElementById("riverpref").options.length;
	var riverindex = document.getElementById("site_id").options.selectedIndex;
	if (document.getElementById("site_id").options[riverindex].value != "" && document.getElementById("site_id").options[riverindex].text != "") {
		station_numbers[rivercount] = document.getElementById("site_id").options[riverindex].value;
		station_labels[rivercount] = document.getElementById("site_id").options[riverindex].text;
		widget.setPreferenceForKey(station_numbers.join("\t"),"stationnumbers");
		widget.setPreferenceForKey(station_labels.join("\t"),"stationlabels");
		document.getElementById("riverpref").options[rivercount] = new Option(station_labels[rivercount],station_numbers[rivercount],false,true);
		document.getElementById("rivermenu").options[rivercount+1] = new Option(station_labels[rivercount],station_numbers[rivercount]);
	}
}

// remove a station from your list
function delRiver()
{
	var riverindex = document.getElementById("riverpref").selectedIndex;
	document.getElementById("riverpref").options[riverindex] = null;
	document.getElementById("rivermenu").options[riverindex+1] = null;
	station_numbers.splice(riverindex,1);
	station_labels.splice(riverindex,1);
	widget.setPreferenceForKey(station_numbers.join("\t"),"stationnumbers");
	widget.setPreferenceForKey(station_labels.join("\t"),"stationlabels");
}

// edit text value of station
function editRiver()
{
	if (document.getElementById("editme")) { //save it
		var riverindex = document.getElementById("riverpref").selectedIndex;
		document.getElementById("riverpref").options[riverindex].text = document.getElementById("editme").value;
		document.getElementById("rivermenu").options[riverindex+1].text = document.getElementById("editme").value;
		station_labels[riverindex] = document.getElementById("editme").value;
		document.getElementById("backmsg").innerHTML = "";
		document.getElementById("editbutton").src = "images/edit.png";
		widget.setPreferenceForKey(station_labels.join("\t"),"stationlabels");
	} else { // creat a text input for edits
		var riverindex = document.getElementById("riverpref").selectedIndex;
		var rivertxt = document.getElementById("riverpref").options[riverindex].text;
		document.getElementById("backmsg").innerHTML = '<input type="text" id="editme" name="editme" value="'+rivertxt+'" style="width: 275px; height: 6px; font-size: 9px;" />';
		document.getElementById("editbutton").src = "images/save.png";
	}
}

// move selected station down up the list
function mvup()
{
	var riverindex = document.getElementById("riverpref").selectedIndex;
	if (riverindex > 0) {
		var copyval = document.getElementById("riverpref").options[riverindex].value;
		var copytxt = document.getElementById("riverpref").options[riverindex].text;
		var prevval = document.getElementById("riverpref").options[riverindex-1].value;
		var prevtxt = document.getElementById("riverpref").options[riverindex-1].text;
		document.getElementById("riverpref").options[riverindex-1] = new Option(copytxt,copyval,false,true);
		document.getElementById("riverpref").options[riverindex] = new Option(prevtxt,prevval);
		document.getElementById("rivermenu").options[riverindex] = new Option(copytxt,copyval);
		document.getElementById("rivermenu").options[riverindex+1] = new Option(prevtxt,prevval);
		station_numbers[riverindex-1] = copyval;
		station_labels[riverindex-1] = copytxt;
		station_numbers[riverindex] = prevval;
		station_labels[riverindex] = prevtxt;
		widget.setPreferenceForKey(station_numbers.join("\t"),"stationnumbers");
		widget.setPreferenceForKey(station_labels.join("\t"),"stationlabels");
	}
}

// move selected station down on the list
function mvdn()
{
	var riverindex = document.getElementById("riverpref").selectedIndex;
	if (riverindex < document.getElementById("riverpref").length) {
		var copyval = document.getElementById("riverpref").options[riverindex].value;
		var copytxt = document.getElementById("riverpref").options[riverindex].text;
		var nextval = document.getElementById("riverpref").options[riverindex+1].value;
		var nexttxt = document.getElementById("riverpref").options[riverindex+1].text;
		document.getElementById("riverpref").options[riverindex+1] = new Option(copytxt,copyval,false,true);
		document.getElementById("riverpref").options[riverindex] = new Option(nexttxt,nextval);
		document.getElementById("rivermenu").options[riverindex+2] = new Option(copytxt,copyval);
		document.getElementById("rivermenu").options[riverindex+1] = new Option(nexttxt,nextval);
		station_numbers[riverindex+1] = copyval;
		station_labels[riverindex+1] = copytxt;
		station_numbers[riverindex] = nextval;
		station_labels[riverindex] = nexttxt;
		widget.setPreferenceForKey(station_numbers.join("\t"),"stationnumbers");
		widget.setPreferenceForKey(station_labels.join("\t"),"stationlabels");
	}
}

// some modified apple stuff
function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget) {
		widget.prepareForTransition("ToBack");		// freezes the widget
	}
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over
	}
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget) {
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	}
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget) {
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
	}
}